﻿Type=Class
Version=3.96
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private ws As WebSocket 'ignore
	' will hold our page information
	Public page As ABMPage
	' page theme
	Private theme As ABMTheme
	' to access the constants
	Private ABM As ABMaterial 'ignore	
	' name of the page, must be the same as the class name (case sensitive!)
	Public Name As String = "CompTreeTablePage"  '<-------------------------------------------------------- IMPORTANT
	' name of the app, same as in ABMApplication
	Public AppName As String = "demo"          '<-------------------------------------------------------- IMPORTANT	
	
	' your own variables
	Dim myToastId As Int	
	'Dim PDFName As String	
	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	' build the local structure IMPORTANT!
	BuildPage
End Sub

Private Sub WebSocket_Connected (WebSocket1 As WebSocket)
	Log("Connected")
	ws = WebSocket1	
	
	If ABMShared.NeedsAuthorization Then
		If ws.Session.GetAttribute2("IsAuthorized", "") = "" Then
			ABMShared.NavigateToPage(ws, "../")
			Return
		End If
	End If
	' connect our page with the websocket	
	page.SetWebSocket(ws)	
	' Prepare the page IMPORTANT!
	page.Prepare	
	
	' important!
	Dim view1 As ABMTreeTable = page.Component("view1")
	view1.Refresh		
End Sub

Private Sub WebSocket_Disconnected
	Log("Disconnected")
End Sub

Sub Page_ParseEvent(Params As Map) 
	Dim eventName As String = Params.Get("eventname")
	Dim eventParams() As String = Regex.Split(",",Params.Get("eventparams"))
	If SubExists(Me, eventName) Then
		Params.Remove("eventname")
		Params.Remove("eventparams")
		Select Case Params.Size
			Case 0
				CallSub(Me, eventName)
			Case 1
				CallSub2(Me, eventName, Params.Get(eventParams(0)))					
			Case 2
				If Params.get(eventParams(0)) = "abmistable" Then
					Dim PassedTables As List = ABM.ProcessTablesFromTargetName(Params.get(eventParams(1)))
					CallSub2(Me, eventName, PassedTables)
				Else
					CallSub3(Me, eventName, Params.Get(eventParams(0)), Params.Get(eventParams(1)))
				End If
			Case Else
				' cannot be called diretly, to many param
				CallSub2(Me, eventName, Params)				
		End Select
	End If
End Sub

public Sub BuildTheme()
	' start with the base theme defined in ABMShared
	theme.Initialize("pagetheme")
	theme.AddABMTheme(ABMShared.MyTheme)
	
	' add additional themes specific for this page
	theme.AddTreeTableTheme("view1")
	theme.TreeTable("view1").AddCellTheme("lev1default")
		
	theme.TreeTable("view1").Cell("lev1default").BackColor = ABM.COLOR_LIGHTBLUE
	theme.TreeTable("view1").Cell("lev1default").BackColorIntensity = ABM.INTENSITY_DARKEN3
	theme.TreeTable("view1").Cell("lev1default").ForeColor = ABM.COLOR_WHITE
	theme.TreeTable("view1").Cell("lev1default").IsEditable = True
		
	theme.TreeTable("view1").AddCellTheme("lev2default")
	theme.TreeTable("view1").Cell("lev2default").BackColor = ABM.COLOR_LIGHTBLUE
	theme.TreeTable("view1").Cell("lev2default").BackColorIntensity = ABM.INTENSITY_LIGHTEN2
		
	theme.TreeTable("view1").AddCellTheme("lev3default")
	theme.TreeTable("view1").Cell("lev3default").BackColor = ABM.COLOR_LIGHTBLUE
	theme.TreeTable("view1").Cell("lev3default").BackColorIntensity = ABM.INTENSITY_LIGHTEN4
			
	theme.TreeTable("view1").AddCellTheme("lev4default")
	theme.TreeTable("view1").Cell("lev4default").BackColor = ABM.COLOR_WHITE	
	
	theme.TreeTable("view1").AddCellTheme("lev4right")
	theme.TreeTable("view1").Cell("lev4right").BackColor = ABM.COLOR_WHITE	
	theme.TreeTable("view1").Cell("lev4right").Align = ABM.TABLECELL_HORIZONTALALIGN_RIGHT
	
	theme.TreeTable("view1").AddCellTheme("lev4orange")
	theme.TreeTable("view1").Cell("lev4orange").BackColor = ABM.COLOR_AMBER
	theme.TreeTable("view1").Cell("lev4orange").BackColorIntensity = ABM.INTENSITY_LIGHTEN3
	
	theme.TreeTable("view1").AddTreeIconColorTheme("white")
	theme.TreeTable("view1").TreeIconColor("white").ForeColor = ABM.COLOR_WHITE
	
	theme.AddChartTheme("chart1theme")
	theme.Chart("chart1theme").Serie(ABM.CHART_SERIEINDEX_C).LinePointStrokeWidthPx=8
	theme.Chart("chart1theme").Serie(ABM.CHART_SERIEINDEX_C).LineStrokeWidthPx=5	
	
	' bluegray button
	theme.AddButtonTheme("bluegrey")
	theme.Button("bluegrey").BackColor = ABM.COLOR_BLUEGREY
	theme.Button("bluegrey").BackColorIntensity = ABM.INTENSITY_DARKEN1
End Sub

public Sub BuildPage()
	' initialize the theme
	BuildTheme
	
	' initialize this page using our theme
	page.InitializeWithTheme(Name, "/ws/" & AppName & "/" & Name, False, theme)
	page.ShowLoader=True
	page.PageTitle = "ABMTreeTable"
	page.PageDescription = "The tree table component "	
	page.PageHTMLName = "abmaterial-tree-table.html"
	page.PageKeywords = "ABMaterial, material design, B4X, B4J, SEO, framework, search engine optimization"
	page.PageSiteMapPriority = "0.50"
	page.PageSiteMapFrequency = ABM.SITEMAP_FREQ_MONTHLY
		
	' adding a navigation bar
	ABMShared.BuildNavigationBar(page, "ABMTreeTable", "../images/logo.png", "", "Controls", "ABMTreeTable")
			
	' create the page grid
	page.AddRows(6,True, "").AddCells12(1,"")
	page.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components
	
	' add paragraph	
	page.CellR(1,1).AddComponent(ABMShared.BuildParagraph(page,"par1","With the ABMTreeTable component you can build collapsable tree structures.  You can even use them to create simple reports (see the ABMPrint module).") )
	
	' build an example tree	
	Dim view1 As ABMTreeTable
	view1.Initialize(page, "view1", False, "view1", 20, Array As String("lev1default", "lev2default", "lev3default", "lev4default"), 24)
	view1.CollapseTooltip = "Close"
	view1.ExpandTooltip = "Open"
	
	view1.AddRow(BuildLev1Header(1, "1", "", False, "Ypres"))
	view1.AddRow(BuildLev2Header1(2, "1_1", "1", False, "Menin Gate", "Friday juni 5, 2015"))
	view1.AddRow(BuildLev3Header(3, "1_1_1", "1_1", False , "Hours"))
	view1.AddRow(BuildLev4Body1(4, "1_1_1_1", "1_1_1", False, "ABA", "Alain Bailleul"))
	view1.AddRow(BuildLev4Body1(4, "1_1_1_2", "1_1_1", False, "JSM", "Jones Smith"))
	view1.AddRow(BuildLev4Body1(4, "1_1_1_3", "1_1_1", False, "SBF", "Sindy Belfast"))
	view1.AddRow(BuildLev3Footer1(3, "1_1_2", "1_1", True, "3 pers.", "11 hours"))
	view1.AddRow(BuildLev3Header(3, "1_1_3", "1_1", False, "Done"))
	view1.AddRow(BuildLev4Body2(4, "1_1_3_1", "1_1_3", False, "First floor - swept"))
	view1.AddRow(BuildLev4Body2(4, "1_1_3_2", "1_1_3", False, "Second floor - vacuum-cleaned"))
	view1.AddRow(BuildLev3Footer2(3, "1_1_4", "1_1", True))
	view1.AddRow(BuildLev3Header(3, "1_1_5", "1_1", False, "Used devices"))
	view1.AddRow(BuildLev4Body3(4, "1_1_5_1", "1_1_5", False, "Vacuum Cleaner", "2", "half a day"))
	view1.AddRow(BuildLev3Footer2(3, "1_1_6", "1_1", True))
	view1.AddRow(BuildLev3Header(3, "1_1_7", "1_1", False, "Result"))
	view1.AddRow(BuildLev4Body3(4, "1_1_7_1", "1_1_7", False, "2 dust bins full", "2", "ton"))
	view1.AddRow(BuildLev3Footer2(3, "1_1_8", "1_1", True))
	view1.AddRow(BuildLev3Header(3, "1_1_9", "1_1", False, "Extra info"))
	view1.AddRow(BuildLev4Body2(4, "1_1_9_1", "1_1_9", False, "Everything cleaned, vacuum cleaner needs to be repaired"))
	view1.AddRow(BuildLev3Footer2(3, "1_1_10", "1_1", True))
	view1.AddRow(BuildLev3Header(3, "1_1_11", "1_1", False, "Overview"))
	view1.AddRow(BuildLev4Body4(4, "1_1_11_1", "1_1_11", False, Array As Int(30,50,70,80,100,140,170), Array As Int(100,120,180,150,190,100,70)))
	view1.AddRow(BuildLev3Footer2(3, "1_1_12", "1_1", True))
	view1.AddRow(BuildLev2Footer(2, "1_2", "1", True))
		
	view1.AddRow(BuildLev2Header1(2, "1_3", "1", False, "Big Square", "Friday juni 5, 2015"))
	view1.AddRow(BuildLev3Header(3, "1_3_1", "1_3", False , "Hours"))
	view1.AddRow(BuildLev4Body1(4, "1_3_1_1", "1_3_1", False, "SBF", "Sindy Belfast"))
	view1.AddRow(BuildLev3Footer1(3, "1_3_2", "1_3", True, "1 pers.", "4 hours"))
	view1.AddRow(BuildLev3Header(3, "1_3_3", "1_3", False, "Done"))
	view1.AddRow(BuildLev4Body2(4, "1_3_3_1", "1_3_3", False, "First floor - swept"))
	view1.AddRow(BuildLev4Body2(4, "1_3_3_2", "1_3_3", False, "Second floor - vacuum-cleaned"))
	view1.AddRow(BuildLev3Footer2(3, "1_3_4", "1_3", True))
	view1.AddRow(BuildLev3Header(3, "1_3_5", "1_3", False, "On map"))
	view1.AddRow(BuildLev4Body5(4, "1_3_5_1", "1_3_5", False, 50.8500, 2.8833))
	view1.AddRow(BuildLev3Footer2(3, "1_3_6", "1_3", True))
	view1.AddRow(BuildLev2Footer(2, "1_4", "1", True))
	
	view1.AddRow(BuildLev2Header1(2, "1_5", "1", False, "Swimming pool", "Friday juni 5, 2015"))
	view1.AddRow(BuildLev3Header(3, "1_5_1", "1_5", False , "Hours"))
	view1.AddRow(BuildLev4Body1(4, "1_5_1_1", "1_5_1", False, "SBF", "Sindy Belfast"))
	view1.AddRow(BuildLev3Footer1(3, "1_5_2", "1_5", True, "1 pers.", "4 hours"))
	view1.AddRow(BuildLev3Header(3, "1_5_3", "1_5", False, "Done"))
	view1.AddRow(BuildLev4Body2(4, "1_5_3_1", "1_5_3", False, "First floor - swept"))
	view1.AddRow(BuildLev3Footer2(3, "1_5_4", "1_5", True))
	view1.AddRow(BuildLev3Header(3, "1_5_5", "1_5", False, "Used devices"))
	view1.AddRow(BuildLev4Body3(4, "1_5_5_1", "1_5_5", False, "Vacuum Cleaner", "2", "half a day"))
	view1.AddRow(BuildLev3Footer2(3, "1_5_6", "1_5", True))	
	view1.AddRow(BuildLev2Footer(2, "1_6", "1", True))
	
	view1.AddRow(BuildLev2Header1(2, "1_7", "1", False, "Parking lot", "Friday juni 5, 2015"))
	view1.AddRow(BuildLev3Header(3, "1_7_1", "1_7", False , "Hours"))
	view1.AddRow(BuildLev4Body1(4, "1_7_1_1", "1_7_1", False, "ABA", "Alain Bailleul"))
	view1.AddRow(BuildLev4Body1(4, "1_7_1_2", "1_7_1", False, "JSM", "Jones Smith"))
	view1.AddRow(BuildLev4Body1(4, "1_7_1_3", "1_7_1", False, "SBF", "Sindy Belfast"))
	view1.AddRow(BuildLev3Footer1(3, "1_7_2", "1_7", True, "3 pers.", "11 hours"))
	view1.AddRow(BuildLev3Header(3, "1_7_3", "1_7", False, "Done"))
	view1.AddRow(BuildLev4Body2(4, "1_7_3_1", "1_7_3", False, "First floor - swept"))
	view1.AddRow(BuildLev3Footer2(3, "1_7_4", "1_7", True))
	view1.AddRow(BuildLev3Header(3, "1_7_5", "1_7", False, "Result"))
	view1.AddRow(BuildLev4Body3(4, "1_7_5_1", "1_7_5", False, "2 dust bins full", "2", "ton"))
	view1.AddRow(BuildLev3Footer2(3, "1_7_6", "1_7", True))
	view1.AddRow(BuildLev2Footer(2, "1_8", "1", True))
	
	view1.AddRow(BuildLev1Footer(1, "2", "", True))
	
	view1.AddRow(BuildLev1Header(1, "3", "", False, "Brussels"))
	view1.AddRow(BuildLev2Header1(2, "3_1", "3", False, "Palace", "Friday juni 5, 2015"))
	view1.AddRow(BuildLev3Header(3, "3_1_1", "3_1", False , "Hours"))
	view1.AddRow(BuildLev4Body1(4, "3_1_1_1", "3_1_1", False, "ABA", "Alain Bailleul"))
	view1.AddRow(BuildLev4Body1(4, "3_1_1_2", "3_1_1", False, "SBF", "Sindy Belfast"))
	view1.AddRow(BuildLev3Footer1(3, "3_1_2", "3_1", True, "2 pers.", "8 hours"))
	view1.AddRow(BuildLev3Header(3, "3_1_3", "3_1", False, "Done"))
	view1.AddRow(BuildLev4Body2(4, "3_1_3_1", "3_1_3", False, "First floor - swept"))
	view1.AddRow(BuildLev4Body2(4, "3_1_3_2", "3_1_3", False, "Second floor - vacuum-cleaned"))
	view1.AddRow(BuildLev3Footer2(3, "3_1_4", "3_1", True))
	
	view1.AddRow(BuildLev2Footer(2, "3_2", "3", True))
	
	view1.AddRow(BuildLev1Footer(1, "4", "", True))
		
	page.CellR(1,1).AddComponent(view1)
	
'	Dim btnGetSign As ABMButton
'	btnGetSign.InitializeRaised(page, "btnPrint", "", "", "Create PDF", "bluegrey")
'	page.CellR(1,1).AddComponent(btnGetSign)	
End Sub

Sub BuildLev1Header(depth As Int, treeRowId As String, treeRowParentId As String, isFooter As Boolean, Stad As String) As ABMtreeTableRow
	Dim l As ABMtreeTableRow
	l.Initialize(depth, treeRowId, treeRowParentId, isFooter, "white")	
	Dim cell1 As ABMTreeTableCell
	cell1.Initalize("v1_" & treeRowId & "c1", Stad, 1,24, False, "")
	l.cells.Add(cell1)
	Return l
End Sub

Sub BuildLev1Footer(depth As Int, treeRowId As String, treeRowParentId As String, isFooter As Boolean) As ABMtreeTableRow
	Dim l As ABMtreeTableRow
	l.Initialize(depth, treeRowId, treeRowParentId, isFooter, "white")	
	Dim cell1 As ABMTreeTableCell
	cell1.InitalizeAsIcon("v1_" & treeRowId & "c1", "mdi-content-add", 3,3, "")
	l.cells.Add(cell1)
	Return l
End Sub

Sub BuildLev2Header1(depth As Int, treeRowId As String, treeRowParentId As String, isFooter As Boolean, Straat As String, Datum As String) As ABMtreeTableRow
	Dim l As ABMtreeTableRow
	l.Initialize(depth, treeRowId, treeRowParentId, isFooter, "")	
	Dim cell1 As ABMTreeTableCell
	cell1.Initalize("v1_" & treeRowId & "c1", Straat, 2,12, False, "")
	l.cells.Add(cell1)
	Dim cell2 As ABMTreeTableCell
	cell2.Initalize("v1_" & treeRowId & "c2", Datum, 14,10, False, "")
	l.cells.Add(cell2)
	Return l
End Sub

Sub BuildLev2Footer(depth As Int, treeRowId As String, treeRowParentId As String, isFooter As Boolean) As ABMtreeTableRow
	Dim l As ABMtreeTableRow
	l.Initialize(depth, treeRowId, treeRowParentId, isFooter, "")	
	Dim cell1 As ABMTreeTableCell
	cell1.InitalizeAsIcon("v1_" & treeRowId & "c1", "mdi-content-add", 4,3, "")
	l.cells.Add(cell1)
	Return l
End Sub

Sub BuildLev3Header(depth As Int, treeRowId As String, treeRowParentId As String, isFooter As Boolean, soort As String) As ABMtreeTableRow
	Dim l As ABMtreeTableRow
	l.Initialize(depth, treeRowId, treeRowParentId, isFooter, "")	
	Dim cell1 As ABMTreeTableCell
	cell1.Initalize("v1_" & treeRowId & "c1", soort, 3,21, False, "")
	l.cells.Add(cell1)
	Return l
End Sub

Sub BuildLev3Footer1(depth As Int, treeRowId As String, treeRowParentId As String, isFooter As Boolean, pers As String, time As String) As ABMtreeTableRow
	Dim l As ABMtreeTableRow
	l.Initialize(depth, treeRowId, treeRowParentId, isFooter, "")	
	Dim cell1 As ABMTreeTableCell
	cell1.Initalize("v1_" & treeRowId & "c1", pers, 4,3, False, "")
	l.cells.Add(cell1)
	Dim cell2 As ABMTreeTableCell
	cell2.Initalize("v1_" & treeRowId & "c2", time, 16,4, False, "")
	l.cells.Add(cell2)
	Return l
End Sub

Sub BuildLev3Footer2(depth As Int, treeRowId As String, treeRowParentId As String, isFooter As Boolean) As ABMtreeTableRow
	Dim l As ABMtreeTableRow
	l.Initialize(depth, treeRowId, treeRowParentId, isFooter, "")	
	Dim cell1 As ABMTreeTableCell
	cell1.Initalize("v1_" & treeRowId & "c1", "{NBSP}", 4,3, False, "")
	l.cells.Add(cell1)
	Return l
End Sub

Sub BuildLev4Body1(depth As Int, treeRowId As String, treeRowParentId As String, isFooter As Boolean, Code As String, Naam As String) As ABMtreeTableRow
	Dim l As ABMtreeTableRow
	l.Initialize(depth, treeRowId, treeRowParentId, isFooter, "")	
	Dim cell1 As ABMTreeTableCell
	cell1.Initalize("v1_" & treeRowId & "c1", Code, 4,3, False, "")
	l.cells.Add(cell1)
	Dim cell2 As ABMTreeTableCell
	cell2.Initalize("v1_" & treeRowId & "c2", Naam, 8,8, False, "")
	l.cells.Add(cell2)
	Return l
End Sub

Sub BuildLev4Body2(depth As Int, treeRowId As String, treeRowParentId As String, isFooter As Boolean, Artikel As String) As ABMtreeTableRow
	Dim l As ABMtreeTableRow
	l.Initialize(depth, treeRowId, treeRowParentId, isFooter, "")	
	Dim cell1 As ABMTreeTableCell
	cell1.Initalize("v1_" & treeRowId & "c1", Artikel, 4,19, False, "")
	l.cells.Add(cell1)
	Return l
End Sub

Sub BuildLev4Body3(depth As Int, treeRowId As String, treeRowParentId As String, isFooter As Boolean, Artikel As String, aantal As String, eenheid As String) As ABMtreeTableRow
	Dim l As ABMtreeTableRow
	l.Initialize(depth, treeRowId, treeRowParentId, isFooter, "")	
	Dim cell1 As ABMTreeTableCell
	cell1.Initalize("v1_" & treeRowId & "c1", Artikel, 4,9, False, "")
	l.cells.Add(cell1)
	Dim cell2 As ABMTreeTableCell
	cell2.Initalize("v1_" & treeRowId & "c2", aantal, 15,2, False, "lev4right")
	l.cells.Add(cell2)
	Dim cell3 As ABMTreeTableCell
	cell3.Initalize("v1_" & treeRowId & "c3", eenheid, 17,3, False, "lev4orange")
	l.cells.Add(cell3)
	Return l
End Sub

Sub BuildLev4Body4(depth As Int, treeRowId As String, treeRowParentId As String, isFooter As Boolean, values1 As List, values2 As List) As ABMtreeTableRow
	' create a line chart
	Dim chart1 As ABMChart
	chart1.Initialize(page, "chart" & treeRowId, ABM.CHART_TYPELINE, ABM.CHART_RATIO_GOLDENSECTION, "chart1theme")
		
	' add the labels
	chart1.Labels.AddAll(Array As String("Mon", "The", "Wed", "Thu", "Fri", "Sat", "Sun"))
	' set some options
	chart1.OptionsLine.FullWidth=True
	chart1.OptionsLine.ChartPaddingRight=60 ' because we set fullwidth, we have to adjust so the final label also fits
	chart1.OptionsLine.Serie(ABM.CHART_SERIEINDEX_A).LineSmooth = ABM.CHART_LINESMOOTH_NONE
	chart1.OptionsLine.Serie(ABM.CHART_SERIEINDEX_C).LineSmooth = ABM.CHART_LINESMOOTH_SIMPLE
	chart1.OptionsLine.Serie(ABM.CHART_SERIEINDEX_C).ShowArea = True
	
	' add some series	
	Dim SerieA As ABMChartSerie
	SerieA.InitializeForLine(ABM.CHART_SERIEINDEX_A)
	SerieA.Values.AddAll(values1)
	chart1.AddSerie(SerieA)
	
	Dim SerieC As ABMChartSerie
	SerieC.InitializeForLine(ABM.CHART_SERIEINDEX_C)
	SerieC.Values.AddAll(values2)
	chart1.AddSerie(SerieC)
	
	Dim l As ABMtreeTableRow
	l.Initialize(depth, treeRowId, treeRowParentId, isFooter, "")	
	Dim cell1 As ABMTreeTableCell
	cell1.InitalizeAsComponent("v1_" & treeRowId & "c1", chart1, 4,19, "")
	l.cells.Add(cell1)
	Return l
End Sub

Sub BuildLev4Body5(depth As Int, treeRowId As String, treeRowParentId As String, isFooter As Boolean, lat As Double, lng As Double) As ABMtreeTableRow
	' create the google map
	Dim gm1 As ABMGoogleMap
	gm1.Initialize(page, "gm1" & treeRowId, lat, lng, 15, 350, ABM.GOOGLEMAPTYPE_ROADMAP)
	gm1.Draggable = False
	gm1.HasMapTypeControl = True	
	gm1.HasStreetViewControl = True
	gm1.HasZoomControl = True
	gm1.AddMapType(ABM.GOOGLEMAPTYPE_ROADMAP)
	gm1.AddMapType(ABM.GOOGLEMAPTYPE_TERRAIN)
	gm1.AddMapType(ABM.GOOGLEMAPTYPE_HYBRID)
	gm1.AddMapType(ABM.GOOGLEMAPTYPE_SATELLITE)
	
	Dim l As ABMtreeTableRow
	l.Initialize(depth, treeRowId, treeRowParentId, isFooter, "")	
	Dim cell1 As ABMTreeTableCell
	cell1.InitalizeAsComponent("v1_" & treeRowId & "g1", gm1, 4,19, "")
	l.cells.Add(cell1)
	Return l
End Sub

' clicked on the navigation bar
Sub Page_NavigationbarClicked(Action As String, Value As String)
	page.SaveNavigationBarPosition
	If Action = "ABMTreeTable" Then Return
	If Action = "Contact" Then	
		myToastId = myToastId + 1	
		page.ShowToast("toast" & myToastId, "toastred", "Hello to you too!", 5000)
		Return
	End If
	If Action = "LogOff" Then
		ABMShared.LogOff(page)
		Return
	End If
	ABMShared.NavigateToPage(ws, Value)
End Sub

Sub Page_FileUploaded(FileName As String, success As Boolean)	
	
End Sub

Sub Page_ToastClicked(ToastId As String, Action As String)
		
End Sub

Sub Page_ToastDismissed(ToastId As String)	
	
End Sub

Sub Page_Ready()
	Log("ready!")
	page.RestoreNavigationBarPosition
End Sub

Sub view1_Clicked(TreeRowId As String, TreeCellId As String)
	Log("TreeRowId: " & TreeRowId & "   TreeCellId: " & TreeCellId)
	Dim view1 As ABMTreeTable = page.Component("view1")
	view1.Refresh
End Sub

'Sub btnPrint_Clicked(Target As String)
'	Log("print clicked")
'	
'	'page.ws.RunFunction("doprint", Null)
'	'page.ws.Flush
'	
'	Dim view1 As ABMTreeTable = page.Component("view1")
'	PDFName = "test" & DateTime.Now
'	ABMPrint.PrintToPDF(page, Me, theme, "view1", view1, File.DirApp, PDFName & ".pdf")	
'End Sub
'
'public Sub PDFCreated()
'	Dim lbl As ABMLabel
'	lbl.Initialize(page, "lbl" & PDFName, "{AL}../PDF/" & PDFName & ".pdf" & "{AT}Download here{/AL}", ABM.SIZE_H6, False, "")
'	page.Cell(6,1).AddComponent(lbl)
'	page.Row(6).Refresh	
'End Sub

